//* -*- Mode: Java; tab-width: 2; indent-tabs-mode: nil; c-basic-offset: 2 -*-*/
/***************************************************************
 * bci-handlers.js --------------------------------------------
 *   Place JavaScript event handlers in this file.
 *   Use bci-static.js for functions that are not event handlers.
 * - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - 
 * REQUIRED IMPORTS: 
 *                     manager.js  
 *                  bci-static.js  (Commands, DialogArgs)
 *                   navigator.js  (for common browser functions, see code)
 *              utilityOverlay.js  (toggle tool bar)
 ****************************************************************/
//include("chrome://jslib/content/jslib.js");
//include("chrome://jslib/content/io/file.js");


function bciInit() {
  dd("bciInit()");
  window.removeEventListener("load", bciInit, true);
  dd("removing event listener bciInit");
}


function BCImozInit(aFirstStart) {
  if (aFirstStart) {
    //dd("first start - adding event listeners");
    // insert further commands to be executed only once here
  }
  dd("cyclewindow: " + CycleWindow("navigator:browser"));
  //only load Manager in first window
  if (!CycleWindow("navigator:browser")) {
    dd("BCImozInit(): first time"); 
    if (manager) { //in case it was active already 
      dd("deleting active manager!!!");
      manager.activeMenu = null;
      manager = null; 
      //unregisterBCIObservers();
    }


    //testVar
    //testVar = 20;
    // global variables
    gBundle = document.getElementById("bundle_bci"); 
    
    gPref = new Prefs(); //user set preferences (bci-prefs.js)
    manager = new Manager(); //Manager. Everyone has access to the manager
    gPauseButton = document.getElementById("bci-button-pause");

    gPauseButton.setAttribute("disabled", "false");
    document.getElementById("bci-menuitem-start").setAttribute("disabled", "true");
    document.getElementById("bci-menuitem-stop").setAttribute("disabled", "false");
    
    //enable menuitem "BCIMail" if connected to BCI
    document.getElementById("bci-menuitem-mail").setAttribute("disabled", "false");
    
    //enable menuitem "Select as target"
    try {
      document.getElementById("bci-context-select-target").setAttribute("disabled", "false");
      document.getElementById("bci-select-target").setAttribute("disabled", "false");
    }
    catch (e) {
      dd("no context menu!");
    }
    
    //enable menuitem "BCIMail" if connected to BCI
    document.getElementById("bci-menuitem-mail").setAttribute("disabled", "false");
    
    
    //enable menuitem "Select as target"
    try {
      document.getElementById("bci-context-select-target").setAttribute("disabled", "false");
      document.getElementById("bci-select-target").setAttribute("disabled", "false");
    }
    catch (e) {
      dd("no context menu!");
    }


    manager.init(aFirstStart);
    

  }
  //could add a routine to close the new window after a specified amount of
  //time and bring orig win back to front
  else dd("BCImozInit(): called again. Not instantiating new Manager.");
}


//code taken from navigator.js and modified significantly
function registerBCIObservers()
{
  dd("RegisterBCIObservers()");
  /* Might be able to use this later, check when main window is closing,
     not just any web page! fires too often as is. Possible alternative to
     "quit-application" event, which is not always fired...
     window.parent.addEventListener("unload", BCImozCleanup, true); 
  */
  /* not using "const" or "var" --> BCIobserver is global, can be called
     from manager.shutDown() */
  gBCIobserver = {
    observe: function(subject, topic, data)
    {
      dump("subject: " + subject + "\n");
      dump("topic:   " + topic + "\n");
      dump("data:    " + data + "\n");

      if (topic == "StartSurfing") {
        dump("starting to surf!------------------------------------------\n");
        //obsService.removeObserver(gBCIobserver,"StartSurfing", false);
        //Commands.prototype.getInstance().startCommand();
        loadURI("file:///C:/moz/local_html/index.html");
        
        
      }
      if (topic == "StartDocumentLoad") {
        dump("doc load started.------------------------------------------\n");
        if (manager.activeMenu)
          manager.activeMenu.display(false); // remove frames while loading...
      
        if (gPref.showLoadingPageDialog && manager.pauseBCI != "red") {
          var dargs = new DialogArgs();
          dargs.title    = l10n("waitTitle");
          dargs.message  = l10n("waitMsg"); //use bundle
          dargs.position = "side"; //should obscure feedback window
          manager.displayUserMsg(dargs);
        }
      }

      if (topic == "EndDocumentLoad") {
        //!check for FailDocumentLoad as well and handle ;-)
        dump("loaded doc.-----------------\n");
        //puzzle: remove the following two lines...
        manager.userRead(gPref.viewPageDelay);
        dump("userread\n");
        //logging
        if(manager.activeMenu) {
          if(manager.activeMenu.getTaskFlag()==1) {
            manager.activeMenu.taskID = gTask; // renew mTaskID, it's getting lost somewhere when loading new page
            manager.activeMenu.taskType = gTaskType; //renew taskType, it's getting lost somewhere when loading new page
            manager.activeMenu.findInTree(gTask, gTaskType); // get target index
            manager.activeMenu.display(true); // display frames for target highlighting
          }
        }
       
      }

      if (topic == "FailDocumentLoad") {
        //if supervisor presses STOP, this topic will be broadcast as well
        //test this by choosing a link link www.google.de without http://
        dump("doc load failed.-----------------\n");
        if (manager.msgWin != null) {
          manager.msgWin.close(); //! enhance this.
        }
        // hack: this allows the puzzle to continue after a "swop"
        // because a fail doc load is generated for some reason...
        if (data.substr(0,15) == "javascript:swop") {
          manager.activeMenu.step(-1000); // continue puzzle immediately
        }
      }

      if (topic == "pause") {
        dump("pause this seems to be working...");
        manager.activeMenu.display(false);
        manager.pauseBCI="red";
        //manager.restart();
      }

      if (topic == "StreamData") {
        dump("received stream data.-----------------\n");
        /* if no web page has been loaded yet, nothing happens
         * step notices the current node is z and does nothing.
         * this is important as the BCI system might send data the whole time
         * Addition: after an "action", if no new menu is created, nothing
         * happens. insert return value into function. if leaf reached, do 
         * something (go back, or reload, or start over... */
        var rv, ret;
        if (manager.activeMenu) {
          try {
            rv = manager.activeMenu.step(data);
          } catch (ex) { // no accessible for action, LSP mode "DEL" chosen
            // we have no action for this case yet! --> choose other class
            manager.activeMenu.step(-1000); // back out
            dd("Error. Starting from top of tree...");

          }
          if(manager.activeMenu) {
            //if(logWindow!=null) {//is logging active?
            var taskFlag = manager.activeMenu.getTaskFlag();
            dd("taskFlag " + taskFlag);
            if(taskFlag==1){ //is logging active?
              dd("***************** TaskFlag " + manager.activeMenu.getTaskFlag());
              updatePerformance(); //gets the user performance and displays it        
            }
            if(taskFlag==2) {
              updatePerformance();
              dd("target reached ");
              manager.activeMenu.setTaskFlag(0);
              dd("taskFlag after reset" + manager.activeMenu.getTaskFlag());
            }
            
          }
          dd("Step retval: " + rv);
          if (rv == -1) {
            //BrowserBack();
            dump("Unknown error in |Step|.\n");
          } else if (rv == -3) { // caught on leaf, do something...
            manager.autoStep(gPref.autoStep,"autoBackMsg");
          }
          else if (rv == -2) { // open keyboard, not needed here any more...
            var choice; // type will be |nsIAccessible|
            choice = manager.activeMenu.choice;
            // only open keyboard if it's not open already!
            if (choice && (!manager.msgWin))
              //Commands.prototype.getInstance().openKeyboard(choice);
              manager.msgWin = window.openDialog(gPref.keyboardContent, "", "chrome,dependent,dialog=no,alwaysRaised=yes", choice);
				setTimeout("onOpenKeyboard(manager.msgWin)",400);
          } else if (rv == -99) { // reached leaf node!
            ret = manager.activeMenu.doNodeAction();
            if (ret == -2) { // open keyboard, not needed here any more...
              var choice; // type will be |nsIAccessible|
              choice = manager.activeMenu.choice;
              // only open keyboard if it's not open already!
              if (choice && (!manager.msgWin))
                //Commands.prototype.getInstance().openKeyboard(choice);
                manager.msgWin = window.openDialog(gPref.keyboardContent, "", "chrome,dependent,dialog=no,alwaysRaised=yes", choice);
				setTimeout("onOpenKeyboard(manager.msgWin)",400);
            } else if (ret == -1) {
              dump("Unknown error in doNodeAction.\n");
            }

          }
          /*
          else if (rv == -4) { // open keyboard for URL bar
            var choice = null;
            choice = gUrlBar.inputField;
            dump("inputfield: " + choice + "\n");
            if (choice)
              Commands.prototype.getInstance().openKeyboard(choice);
            dump("closed url keyboard");
          }
*/
        } else {
          dd("no menu active - creating navbar menu"); //!!!auto create from first page?
          manager.createMenu(NAVBAR_1_BUTTONS,1);
        }
      }
      if (topic == "quit-application") { 
        dump("QUIT----------------\n");
        if (manager) {
        //make this global or create new instantiation of manager
          manager.shutDown(); //already gone by this stage??? Yes!
        }
        //pause for a while - but how? Without pause, native code tries to 
        //call back although JS code is already out of memory :-(
        //cf. bug in BugZilla (maybe use settimeout???)

        //oservice.removeObserver(RegisterBCIObservers, "quit-application"); 
        /* do we need this? According to:
           http://lxr.mozilla.org/mozilla1.0/source/xpcom/ds/nsIObserver.idl
           we should actually not be doing this here.
        */
      }
    }
  }

  // This works for "File-->Exit" but not when the window "x" button is clicked
  // Bug fixed in 1.2.1
  //"REFLOW" works for min/maximise, but is called more often than I'd need..
  //..especially when new pages are loading...
  obsService.addObserver(gBCIobserver, "StartSurfing", false);
  obsService.addObserver(gBCIobserver, "StartDocumentLoad", false);
  obsService.addObserver(gBCIobserver, "EndDocumentLoad", false);
  obsService.addObserver(gBCIobserver, "FailDocumentLoad", false);
  obsService.addObserver(gBCIobserver, "StreamData", false);
  obsService.addObserver(gBCIobserver, "pause", false);

try {
      dump("add ev close");
      //window.addEventListener("mousedown", MouseListener, false);
      window.addEventListener("close", onBrowserClose, false);
    } catch (ex) { dump(ex); }


  /* This does not work because JS code is gone by the time 
     xpcom-shutdown event is broadcast :-(
     service.addObserver(gBCIobserver, "xpcom-shutdown", false);
  */
}

function unregisterBCIObservers() {
  dd("unregisterBCIObservers()");
  try {
    //window.removeEventListener("mousedown", MouseListener, false);
    window.removeEventListener("close", onBrowserClose, false);
  } catch (ex) {
    dd("error removing event listener");
  }
  obsService.removeObserver(gBCIobserver,"StartSurfing", false);
  obsService.removeObserver(gBCIobserver,"StartDocumentLoad",false);
  obsService.removeObserver(gBCIobserver,"EndDocumentLoad", false);
  obsService.removeObserver(gBCIobserver,"FailDocumentLoad", false);
  obsService.removeObserver(gBCIobserver,"StreamData", false);
  obsService.removeObserver(gBCIobserver,"pause", false);
}

function onBrowserClose() {
  dump ("::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::close\n");
  manager.shutDown();
}


/**
 * onOpenKeyboard: handler to place keyboard window and open a bciMenu
 * @param aKbdWin Reference to the keyboard window (manager.msgWin)
 */

function onOpenKeyboard(aKbdWin) {
  dd("onOpenKeyboard()");
  //aKbdWin.sizeToContent();

  // get accbl coords (o prefix on variable denotes an Object)
  var oAccX = new Object(), oAccY = new Object(); 
  var oAccWidth = new Object(), oAccHeight = new Object();
  
  //var acc = manager.activeMenu.choice;
  var acc = aKbdWin.arguments[0];
  //test if no acc...

  // XPConnect requires objects to be passed as [out] variables
  acc.getBounds(oAccX, oAccY, oAccWidth, oAccHeight);

  // get the integer values out of the objects
  var accX = oAccX.value; var accY = oAccY.value;
  var accWidth = oAccWidth.value; var accHeight = oAccHeight.value;

  dd("acc x,y,wid,height: " + accX + "," + accY + "," + accWidth + ","+accHeight);

  // get screen dimensions
  var scrWidth = window.screen.availWidth;
  var scrHeight = window.screen.availHeight;
  var scrTop = window.screen.availTop; // incorrect value if taskbar covers half the screen at the top

  dd("scr wid,height,top: " + scrWidth+","+scrHeight+","+scrTop);

  // get keyboard dimensions
  var width = aKbdWin.window.outerWidth;
  var height = aKbdWin.window.outerHeight;

  dd("keyb wid,height: " + width+","+height);

  // new keyboard position
  var x,y;
  var position = gPref.keyboardPosition; // change |position| if neccessary
  //x = scrWidth - width; 
  y = scrTop + scrHeight - height;

  // determine |y| coordinate for keyboard window
  if (position == 0) {
    if ((scrTop + height) < accY) 
      y = scrTop;
    else position = 2; // top of screen impossible, try just below acc
  }
  if (position == 3) {
    if ((scrHeight - height - accHeight) > accY)
      y = (scrTop + scrHeight - height);
    else position = 1; // bottom of screen not possible, try just above acc
  }

  if (position == 1) { // just above acc
    y = (accY - height);

    if (y < scrTop) // keyboard does not fit above acc
      position = 2;
  }
  if (position == 2) { // just below acc
    y = accY + accHeight;
    if (y + height > scrHeight + scrTop) // keyboard does not fit below acc
      if (accY - height < scrTop) // no fit above either: acc is very big!
        y = scrTop + scrHeight - height; // place in bottom right corner
      else y = accY - height; // above
  }

  // determine |x| coordinate for keyboard window
  x = accX; // default
  if (x > gPref.primaryDisplaySize) // if we are using a double display...
    scrwidth += gPref.primaryDisplaySize; // ...adjust screen width
  if (x + width > scrWidth) // keyboard offscreen to the right
    x = scrWidth - width;

  aKbdWin.moveTo(x,y);
  dd("keyboard moved to: " + x + "," + y);
  dd("position now: " + position);

  // create a new menu on window
  manager.createMenu("dialog",1); // create and display immediately

  aKbdWin.title = "Tastatur";
}



function linkArea() {
  dd("linkArea()");
  //for testing, just add static stuff
  var du = new DirUtils();
  var dstr = du.getPrefsDir();
  dd("pd: " + dstr);
  dstr += "\\mike.rdf";
  dd("pd: " + dstr);

  var url = getWebNavigation().currentURI.spec;

  var rdf = new RDFFile(dstr);

  var node = rdf.getNode("bci:site:" + url);
  node.setAttribute("LinkArea", "0,0,100,100");
  rdf.flush();
  var info = node.getAttribute("LinkArea");
  dd("la: " + info);

}

function menu2dot() {
   if (manager.activeMenu) {
    var fileName = "menu";
    if (gPref.addDateToDotFile) {
      var now = new Date();
      var val;
      fileName += now.getFullYear() + "-"; //add year
      val = now.getMonth() + 1;
      if (val < 10) fileName += "0" + val + "-"; //add month
      else fileName += val + "-";
      val = now.getDate();
      if (val < 10) fileName += "0" + val + "_"; //add date
      else fileName += val + "_";

      var reg = /\S{8}/; // time substring
      // get time substring from format: Wed, 29 Jan 2003 19:49:21 GMT
      var str = new String(reg.exec(now.toUTCString()));
      str = str.replace(/:/g,"-"); // modifier g finds all occurences of ":"
      fileName += str; // add time to filename
      dd("file: " + fileName);
    }
    for (verb=0; verb < 3; verb++) 
      manager.activeMenu.toDotFile(fileName+"_v"+verb+".dot", verb);
    }
    else dd("no menu active.");
}


function JStest() {
  dd("page loaded.");
  var theDoc = window.content.document;
  //DumpDOM(theDoc); //watch out! this is a lot!
  var lnks = new Array();
  lnks =  grabLinks(window._content, theDoc);
  dd("lnks.length: " + lnks.length);
  for (var i = 0; i < lnks.length; i++) {
    dd(i + ": " + lnks[i]);
    if (lnks[i].nodeType == Node.TEXT_NODE) {
      dump("Set to parent node!\n");
      lnks[i] = lnks[i].parentNode;
    }
    dd("lnks["+i+"]: " + lnks[i]);
    dd("lnks["+i+"].length: " + lnks[i].length);

    for (var j=0; j < lnks[i].length; j++) {
      dd(j+": "+lnks[i].item(j));
      DumpDOM(lnks[i].item(j));
    }
    /*
    for (var j=0; j < lnks[i].length; j++) {
      dd(j+": "+lnks[i].item(j));
      var flasher = new Flasher("FF0000",1,1200,100,false); //initializes inFlasher component in Flasher.js
      flasher.mElement=lnks[i].item(j);
      flasher.paintOn();
    }
    */
  }
}



function statusBarMsg(aText) {
  window.status = aText;
  setTimeout("window.status = '';",2000);
}

function doTour() {
  loadURI("resource:/res/bci/tour/1.xhtml");
  //dd(document.getElementById("bci-back-button"));


}


function menuOff() {
  document.getElementById("bci-menuitem-start").setAttribute("disabled", "false");
  document.getElementById("bci-menuitem-stop").setAttribute("disabled", "true");
  gPauseButton.setAttribute("disabled", "true");
  //disable menuitem BCIMail
  document.getElementById("bci-menuitem-mail").setAttribute("disabled", "true");
  
  dd("bcimoz stopped.");
  if (manager)
    manager.shutDown();
}

function showVersion() {
  var vstr = "Javascript code: " + BCI_JS_VERSION + "\nC++ code       : ";
  if (manager && manager.activeMenu) 
    vstr += "0." + manager.activeMenu.version;
  else 
    vstr += "No c++ menu active.";
  dd(vstr);

  //alerts should use the prompt service
  var psvc = XPCU.getService("@mozilla.org/embedcomp/prompt-service;1",
                             "nsIPromptService");
  psvc.alert(window, "Version Information", vstr);
  psvc = null; //reduce the ref count on this service
}

function showPageInfo() {
  dd("gBookmarksService: " + gBookmarksService);
  dd("gLastValidURLStr: " + gLastValidURLStr);
  dd("gLastValidURL: " + gLastValidURL);
  dd("appCore: " + appCore);
  dd("gBrowser: " + gBrowser);
  dd("gFocusedDocument: " + gFocusedDocument);

  dd("Browser URL: " + getBrowserURL());
  dd("Number of frames: " + getContentAreaFrameCount());
  gPref.show();
}

function toggleTool() {
  dd("toogletool");
  goToggleToolbar(NAVBAR_1,'bci-menuitem-toggleBar'); //see utilityOverlay.js
}

function togglePause() {
  dd("togglePause");
  var currentMode = manager.pauseBCI;
  dd("current: " + currentMode);
  if (currentMode == "red") {
    //clear any open pause windows
    manager.pauseBCI = "yellow";
    closeMsgWindows(true);
  } else { //current mode is yellow or green --> set to red
    manager.pauseBCI = "red";
  }
    
}




var oldX;
var oldY;

function processMouseMove(aEvent) {
  dd("pmm");
  var grid = gPref.grid;
  var xDir = parseInt((aEvent.clientX - oldX) / grid);
  var yDir = parseInt((aEvent.clientY - oldY) / grid);
  //only process if movement is large enough
  if ((xDir != 0) || (yDir != 0)) {
    //do action
    window.status = l10n("superMode");
    setTimeout("window.status=' '",1500);
    oldX = aEvent.clientX;
    oldY = aEvent.clientY;
    lastMoveTime = aEvent.timeStamp;
  }
}

function stop() {
  manager.sock.sendData(send_STOP);
}

function onTextFieldFocus(aEvent) {
  dd("onTextFieldFocus( " + aEvent + ")");
  dd("target: " + aEvent.target);
  // retrieve the accessible for this DOM element
  var acc;
  try {
    acc = XPCU.QI(aAccessible, "nsIAccessible");
  } catch (ex) {
    dd("element is not an nsIAccessible.");
    dd(ex);
    acc = accService.getAccessibleFor(aEvent.target);
  }
  
  dd("openKeyboard(" + acc + ")");
  // bensch: open keyboard not working with Commands
  manager.msgWin = window.openDialog(gPref.keyboardContent, "", "chrome,dependent,dialog=no,alwaysRaised=yes", acc);
        setTimeout("onOpenKeyboard(manager.msgWin)",400);
        
  //var c;
  //c = Commands.prototype.getInstance();
  //c.openKeyboard(acc);
}

////////////////////////////////////////////////////////////////////////////
//// Listener Objects

// The problem here is that acc->doAction causes a "click" or "mousedown"
// event to fire on the navbar - which puts Nessi into pause!!!
// So for now, you will just have to press the Pause BCI button to pause
// Nessi before doing anything in the menus etc.

var MouseListener = {
  handleEvent: function(aEvent)
  {
    var target = aEvent.target;
    if (aEvent.type == "mousedown") {
      dump("mouse click!\n");
      dump("target: " + target + "\n");
      if (manager.pauseBCI == "red") {
        dump("pausing already...");
      } else if (target != gPauseButton) {
        // supervisor is intervening, send Nessi into "pause" mode
        manager.pauseBCI = "red";
      } else dd("pause button!!!");
    }
  }
}

var MouseBarListener = {
  handleEvent: function(aEvent)
  {
    if (aEvent.type == "mousedown") {
      dump("down");
      if (aEvent.target.localName == "toolbarbutton")
      aEvent.target.collapsed = true;
      else { // finish deselecting icons
        var navBar = document.getElementById(NAVBAR_1); // icons for user commands
        navBar.removeEventListener("mousedown",MouseBarListener,false);
        //navBar.style.backgroundColor = temp;
        //navBar.setAttribute("background-color", temp);
        BrowserBack(); // return to previous page
      }
    }
    aEvent.preventDefault();
  }
}

var temp = null;

function reduceIcons() {
  dd("reduceicons");
  manager.pauseBCI = "red";
  var navBar = document.getElementById(NAVBAR_1); // icons for user commands
  if (navBar) { 
    // show all buttons in the beginning
    var childNodes = navBar.firstChild.childNodes;
    for (var i = 0; i < childNodes.length; i++) {
      if (childNodes[i].localName == "toolbarbutton") // leave spacers etc.
        childNodes[i].collapsed = false;
    }
    loadURI("resource:/res/bci/icons.xhtml");
    navBar.addEventListener("mousedown",MouseBarListener,false);
  }
}

/***********************************************************************
 * Test functions, can be deleted or moved later.
 ***********************************************************************/


function bci_notify()
{
      //event.preventDefault();
      //Find out whether BCImoz is active. Don't continue if not active.
      dump("WOW! FOCUS!!!\n");
      try {
        //obsService = Components.classes["@mozilla.org/observer-service;1"].
        //getService(Components.interfaces["nsIObserverService"]);

dump("we got: " + obsService + "\n");
} catch (ex) {
	dump("Error getting observer service.\n" + ex);
}
try {
	obsService.notifyObservers(null,"InputFieldFocus",this);
        dump("sent event\n");
      } catch (ex) {
	dump("Error notifying observers.\n" + ex);
      }

    }

function testM() {
  manager.activeMenu.display(true);
  dd("displaying.");
  
}

function cMenu() {
  dd("just the constructor.");
  var myMenu = XPCU.createInstance("@mozilla.org/inspector/dom-view;1","inIDOMView");
  dd("dumping...");
  window.TraceMallocDumpAllocations('allocations.log');
  dd("finished.");
}

/*
//preferred for 1.2.1:
 var myArray = XPCU.createInstance("@mozilla.org/array;1","nsIMutableArray");
*/

/*function displayManager() {
  dd("displayManager() ");
  
  if(manager) {
    dd("manager " + manager);
   
  }
}*/



/************************************************************************
*
* function for logging user performance
*
*************************************************************************/

function select(element) {
   
  //var element = document.popupNode; //if clicked on an image link, you get the image node and not the link node!
									// returnvalue Node (nsIDomNode)
									
  								
  dd("element " + element);	
  								
  							
									
  // to identify uniquely a clicked elment either element.name, acc.name or element.id is used  								
  // try to get element.name (= domNode.name)
  if(element.name) {
    dd("element.name is used: "+ element.name);
    gTask = element.name;//identifier (eg. file:///C:/moz/local_html/dfb/fussball.jpg)
    dd("gTask "+ gTask);
    gTaskType = 1;// 1 means element.name
    
  }		
  else {
  
    try {
      // get accessible for element
      acc = accService.getAccessibleFor(element);
      acc.QueryInterface(Components.interfaces.nsIAccessible);
      dd("acc " + acc);
      acc.QueryInterface(Components.interfaces.nsIAccessible);
      //try to get acc.name
      if(acc.name!=null) {
        dd("acc.name is used: " + acc.name);
        gTask = acc.name;//identifier (eg. file:///C:/moz/local_html/dfb/fussball.jpg)
        dd("gTask "+ gTask);
        gTaskType = 2;// 2 means acc.name
      }
      else {
        // try to get element.id (= domNode.id)
        if(element.id!=null) {
          dd("element.id is used: "+ element.id);
          gTask = element.id;
          dd("gTask "+ gTask);
          gTaskType = 3;
        }
        else {
          dd("Can't get a unique element identifier!");
        }	
      }
    }
    catch (e) {
      dd("Can't get identifier!");
      gTask = null;
      gTaskType = 0;
    }
  } 
  
  		
  
  	
  //set mTaskID and mTaskType if bciMenu already exists				
  try {    
    if(manager.activeMenu){ 
      if(manager.activeMenu.isGConfMatricesEmpty() ) {
          dd(" gConfMatrices is empty... Initialising...."); // initializes matrix array
          manager.activeMenu.initConfMatr();
      }
      //the clicked element is located in mNodes, so we can go on with the elements accessible
      manager.activeMenu.findInTree(gTask, gTaskType); // get the taskID for target highlighting and role checking
      
      if(manager.activeMenu.isTargetValid()) {// is selected target valid?
        //if target is valid, logging is starting
        dd("valid target");
        manager.activeMenu.addConfMat(); // storing confusion matrices
        
        var c = manager.activeMenu.getTaskCount();//counts how many targets were logged --> performance calculation
        
        manager.activeMenu.taskID = gTask; //identifier (eg. file:///C:/moz/local_html/dfb/fussball.jpg)
        manager.activeMenu.taskType = gTaskType; //which identifier is used: element.name, acc.name, element.id 
        manager.activeMenu.setTaskName(c, gTask); // sets taskName in gConfMatrices[c]
        
         
        manager.activeMenu.setTaskFlag(1); //logging is active
        manager.activeMenu.display(true); //show frames
        logWindow();//window showing user performance in percent
        // 22.11.06 (bensch): the following line might have to be commented out if there are problems
        document.getElementById("bci-menuitem-stop-logging").setAttribute("disabled", "false");//activate "stop-logging" menuitem
      }
      else {
        dd("This is not a valid target! " + gTask);
        dd("Try again!");
        // prompt error information
        //var psvc = XPCU.getService("@mozilla.org/embedcomp/prompt-service;1", "nsIPromptService");
        //psvc.alert(window, "Error", "This is not a valid target! Try again!");
      }
      
    }
    
  }
  catch (e) {
    dd("manager.activeMenu doesn't exist yet");
    dd("-------------------------------------------------------------------");
  }	  
}

//open logging window displaying user performance
function logWindow() {

  //open output window
 if(manager) {
    if(logWin==null) {
      if(gPref) {
        dd("open LogWindow");
        logWin = window.open(gPref.logWindowHTML, "LogWindow","chrome, height=200, width=300");
        //logWin = window.open("file:///c://moz//local_html//logWindow.html", "LogWindow","chrome, height=200, width=250");
      	//logWin = window.openDialog("file:///c://moz//local_html//logWindow.xhtml", "LogWindow","chrome");
      	//logWin.sizeToContent();
      	//logWin.height=300;
 
      }
    }
 
 }
 
 fileOutput();  //write matrix to file 	 
}


/************************
* FILE OUTPUT
***********************/
function fileOutput() {

var output ="";//output string
 var i, length, a;
 var date = new Date(); // append date to filename

var filename = (gPref.filename +"_"+ date.getDate() +"_"+ (date.getMonth()+1) + "_"+ date.getFullYear()+".txt");
 //dd(" filename "+ filename);
  
 var f = new File(filename); // file stores confusion matrices
 f.create();
 f.open("wa"); //open file to write and append
 
 if(manager.activeMenu) {
   length = (manager.activeMenu.classCount)*(manager.activeMenu.classCount);//length of array where hits and misses are stored
   //dd("length " + length);
  
   var a = manager.activeMenu.getTaskCount(); 
   if(a>1 ) {
     //get confusion matrix of the task before       
     output += matrixToString(a-1,length);//convert array to matrix and write it to file
     //output += manager.activeMenu.getFloatPerformance(a-1);
     output += "task performance: " + manager.activeMenu.getFloatPerformance(a-1) + "%\n";
     output += "total performance: " + manager.activeMenu.getFloatPerformance(0) + "%\n";
     output += "\n\n";
     //dd(output);
   }
 }
   
 f.write(output);
 f.close();
 


}



/******************
* GRAPHICAL OUTPUT
*
* display user performance and update it after each step
*******************/
function updatePerformance() {
    dd("updatePerformance()....");
    if(manager.activeMenu) {
      var a = manager.activeMenu.getTaskCount();
      if(a>0) {
        // display task performance
        var perf = manager.activeMenu.getIntPerformance(a);
        var str = perf;
        // updating logWindow
        logWin.document.getElementsByTagName("td")[2].firstChild.data=str;
        
        // display total performance
        perf = manager.activeMenu.getIntPerformance(0);
        str = perf;
        // updating logWindow
        logWin.document.getElementsByTagName("td")[10].firstChild.data=str;
        
      }
      
    }
    
}
  


// called when "stop logging" is presed: last task matrix and total confusion matrix is written to file
// also called in manager.shutDown() ?
function completeLogFile() {
  dd("completeLogFile()...");
  
  /****************
  * FILE OUTPUT
  ****************/
  
  var output =""; //output string
  var date = new Date(); // append date to filename
  var filename = (gPref.filename +"_"+ date.getDate() +"_"+ (date.getMonth()+1) + "_"+ date.getFullYear()+".txt");
  
  var f = new File(filename);
  f.create();
  f.open("wa"); //open file to write and append
 
  if(manager.activeMenu) {
    if(!manager.activeMenu.isGConfMatricesEmpty()) {
    length = (manager.activeMenu.classCount)*(manager.activeMenu.classCount);//length of array where hits and misses are stored
    //dd("length " + length);
   
    
    //write last task matrix to file  
    var a = manager.activeMenu.getTaskCount();
    output += matrixToString(a,length);
    output += "task performance: " + manager.activeMenu.getFloatPerformance(a) + "%\n";
    output += "total performance: " + manager.activeMenu.getFloatPerformance(0) + "%\n\n";
    
    // write total confusion matrix to file
    output += matrixToString(0,length);
    output += "total performance: " + manager.activeMenu.getFloatPerformance(0) + "%\n";
    output += "=========================================================\n";
   
    dd(output);
    }
   
 }
 f.write(output);
 f.close();
 document.getElementById("bci-menuitem-stop-logging").setAttribute("disabled", "true");
 if(manager) {
   manager.createMenu("content",1);//create new menu (remove target highlighting)
 }
 // prompt saving information
 /*var str = "Datei " + filename + " gespeichert! ";
 var psvc = XPCU.getService("@mozilla.org/embedcomp/prompt-service;1",
                             "nsIPromptService");
 psvc.alert(window, "Saving information", str);
 */
}



//=================== helper function =======================
// converts confusion matrix to string 
// aTask = task number in gConfMatrices 
// aLength = length of gConfMatrices[].matrixArray 
function matrixToString(aTask, aLength) {
  var output="";
  
  output += manager.activeMenu.getTaskName(aTask, aLength);
  //dd("output taskName " + output);
  output += "\n\n";
     
  for(i=0; i<aLength; i++) {
    //dd(manager.activeMenu.getMatrixValue(i) + "");
    output += manager.activeMenu.getMatrixValue(aTask, i);
    output += "	";
    if((i+1)%manager.activeMenu.classCount ==0) { //new row in matrix ->new line
      output += "\n\n";
    }
  }
  
  return output;
  
}


