/* -*- Mode: C++; tab-width: 2; indent-tabs-mode: nil; c-basic-offset: 2 -*-
 *
 * The contents of this file are subject to the Mozilla Public License
 * Version 1.1 (the "License"); you may not use this file except in
 * compliance with the License. You may obtain a copy of the License at
 * http://www.mozilla.org/MPL/ 
 * 
 * Software distributed under the License is distributed on an "AS IS" basis,
 * WITHOUT WARRANTY OF ANY KIND, either express or implied. See the License
 * for the specific language governing rights and limitations under the
 * License. 
 *
 * The Original Code is BCI Application (generated by MichaelB)
 * 
 * The Initial Developer of the Original Code is
 * Netscape Communications Corporation
 * Portions created by Netscape are
 * Copyright (C) 1998 Netscape Communications Corporation.
 *
 * Alternatively, the contents of this file may be used under the terms of
 * either the GNU General Public License Version 2 or later (the "GPL"), or
 * the GNU Lesser General Public License Version 2.1 or later (the "LGPL"),
 * in which case the provisions of the GPL or the LGPL are applicable instead
 * of those above. If you wish to allow use of your version of this file only
 * under the terms of either the GPL or the LGPL, and not to allow others to
 * use your version of this file under the terms of the MPL, indicate your
 * decision by deleting the provisions above and replace them with the notice
 * and other provisions required by the GPL or the LGPL. If you do not delete
 * the provisions above, a recipient may use your version of this file under
 * the terms of any one of the MPL, the GPL or the LGPL.
 *
 * Contributor(s):
 * Thanks to the chatzilla guys 
 *
 */

/***************************************************************
 * BCIConnection-------------------------------------------------
 *   Object representing the socket connection to the server
 *   (some BCI software implementing the BCImoz comm. protocol)
 * - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - 
 * REQUIRED IMPORTS: bci-utils.js (for XPCU usage)
 *                   bci-static.js (for obsService)
 ****************************************************************/

/*const NS_ERROR_MODULE_NETWORK = 2152398848; 
const NS_ERROR_UNKNOWN_HOST = NS_ERROR_MODULE_NETWORK + 30;
const NS_ERROR_CONNECTION_REFUSED = NS_ERROR_MODULE_NETWORK + 13;
const NS_ERROR_NET_TIMEOUT = NS_ERROR_MODULE_NETWORK + 14;
const NS_NET_STATUS_RESOLVING_HOST = NS_ERROR_MODULE_NETWORK + 3;
const NS_NET_STATUS_CONNECTED_TO = NS_ERROR_MODULE_NETWORK + 4;
const NS_NET_STATUS_SENDING_TO = NS_ERROR_MODULE_NETWORK + 5;
const NS_NET_STATUS_RECEIVING_FROM = NS_ERROR_MODULE_NETWORK + 6;
const NS_NET_STATUS_CONNECTING_TO = NS_ERROR_MODULE_NETWORK + 7;
*/
const SIS_CTRID = "@mozilla.org/scriptableinputstream;1";
const nsIScriptableInputStream = Components.interfaces.nsIScriptableInputStream;

function toScriptableInputStream (i)
{
    var si = Components.classes["@mozilla.org/scriptableinputstream;1"];
    si = si.createInstance();
    si = si.QueryInterface(Components.interfaces.nsIScriptableInputStream);
    si.init(i);
    return si;
}


// lays the foundations for the socket connection
// thanks to the chatzilla guys...
function BCIConnection()
{
    //!MichaelB: use XCPU
    //get the component we need
    var sockServiceClass = Components.classes["@mozilla.org/network/socket-transport-service;1"]; //.createInstance();
    if (!sockServiceClass)
	throw ("No Socket Service Class!");

    //get the interface we need from that component
    var sockService = sockServiceClass.getService();
    if (!sockService)
	throw ("No Socket Interface!");
    
    this._sockService = sockService.QueryInterface
	(Components.interfaces.nsISocketTransportService);

    this.wrappedJSObject = this;
}

BCIConnection.prototype =
{
  ////////////////////////////////////////////////////////////////////////////
  //// Initialization
    
    //readyReceived: false,
    //classesReceived: false,
    //nrClasses: 2,
    streamListener: null,
    //////////////////////////////////////////////////////////////////////////
    //// Properties
    get nrClasses() { 
        if (this.streamListener) return this.streamListener.nrClasses;
        else return 0;
    },
    set nrClasses(aVal) { //MB: can I delete the whole function?
        dd("nrClasses is read-only.");
    },
    get readyReceived() {
        if (this.streamListener) return this.streamListener.readyReceived;
        else return false; // default
    },
    get classesReceived() {
        if (this.streamListener) return this.streamListener.classesReceived;
        else return false; // default
    },
    get resultValue() {
        if (this.streamListener.readyReceived && this.streamListener.classesReceived)
        return this.streamListener.resultValue;
        else {
            dd("BCI has not sent ready and classes yet.");
            return 0;
        }
    },

    get msAfterTrial() {
      if (this.streamListener) {
        var ms = new Date().getTime() - this.streamListener.lastTrialResult; 
        //dd("gettime: " + new Date().getTime());
        //dd("lastTrialResult: " + this.streamListener.lastTrialResult);
        //dd("returning ms since last trial: " + ms);
        if (ms < 0)  {
          //dd("mslt ms was negative!");
        
          ms = 0;
        }
        return ms;
      } else {
        dd("Error getting next trial time...");
        return 0;
      }
    },

    get msBeforeTrial() {
      if (this.streamListener) {
        var ms = this.streamListener.lastTrialResult + this.streamListener.trialLength - new Date().getTime();
        if (ms < 0) {
          //dd("mtnt ms was negative!");
          ms = 0;
        }
        //dd("returning ms till next trial: " + ms);
        return ms;
      } else return 0;
    }
}

BCIConnection.prototype.checkConnection = 
function bci_chkconnect()
{
    dd("BCIConnection::checkConnection()");
    dd(this.readyReceived);
    dd(this.classesReceived);
}

//returns TRUE if connection established, FALSE on failure
BCIConnection.prototype.connect =
function bci_connect(host, port, observer) //bind, tcp_flag removed
{
    this.host = host.toLowerCase();
    this.port = port;

if(jsenv.HAS_STREAM_PROVIDER)
{
   dumpln("in der Schleife");
    this._transInterface = this._sockService.
        createTransport(host, port, null, 0, 0); //out retval nsITransport
    
    if (!this._transInterface)
    throw("No transport!");


    if (jsenv.HAS_NSPR_EVENTQ) 
    {   /* we've got an event queue, so start up an async write */
    /* assume that we've got an event queue, so start up an async write */
    this._streamProvider = new StreamProvider(observer); 
    this._write_req = 
        this._transInterface.asyncWrite(this._streamProvider, this, 0, -1, 0);
        //nsIStreamProvider, nsISupports, offset, count, flags
    }
    
    else
        {
            /* no nspr event queues in this environment, we can't use async
             * calls, so set up the streams. */
            this._outputStream = this._transInterface.openOutputStream(0, -1, 0);
            if (!this._outputStream)
                throw "Error getting output stream.";
            this._inputStream =
                toScriptableInputStream(this._transInterface.openInputStream(0,
                                                                        -1, 0));
            if (!this._inputStream)
                throw "Error getting input stream.";
        }     
 }
 
 else
    {
        /* use new necko interfaces */
        this._transInterface = this._sockService.createTransport(null, 0, host, port,
                                                            null);
        if (!this._transInterface)
            throw ("Error creating transport.");

        /* if we don't have an event queue, then all i/o must be blocking */
        var openFlags;
        if (jsenv.HAS_NSPR_EVENTQ)
            openFlags = 0;
        else
            openFlags = Components.interfaces.nsITransport.OPEN_BLOCKING;

        /* no limit on the output stream buffer */
        this._outputStream = 
            this._transInterface.openOutputStream(openFlags, 4096, -1);
        if (!this._outputStream)
            throw "Error getting output stream.";
        this._inputStream = this._transInterface.openInputStream(openFlags, 0, 0);
        if (!this._inputStream)
            throw "Error getting input stream.";
    }
    this.connectDate = new Date();
    this.isConnected = true;

	// startAsyncRead function ???
    // Stream Listener will call "onDataAvailable" if data is received
    var listener=XPCU.getService("@mozilla.org/network/async-stream-listener;1"
                                 ,"nsIStreamListener");
    if (!listener)
        throw("No listener!");
    this.streamListener = new StreamListener(listener);

    if (jsenv.HAS_STREAM_PROVIDER)
    {
        this._transInterface.asyncRead(this.streamListener,this,0,-1,0);
    }
    else
    {
        var cls = Components.classes["@mozilla.org/network/input-stream-pump;1"];
        var pump = cls.createInstance(Components.interfaces.nsIInputStreamPump);
        pump.init(this._inputStream, -1, -1, 0, 0, false);
        pump.asyncRead(this.streamListener, this);
    }
    
    //this.startAsyncRead(new StreamListener(listener)); //this.streamListener

    return this.isConnected;
}

BCIConnection.prototype.disconnect =
function bci_disconnect()
{
    this.isConnected = false; //added this
    dd("connected transport count: " + this._sockService.connectedTransportCount+"\n");
    dd("in use transport count: " + this._sockService.inUseTransportCount+"\n");
    //if (this._sockService.connectedTransportCount > 0) { 
      dd("trying three things...\n");
      if ("_inputStream" in this && this._inputStream) {
        this._inputStream.close();
        dd("closed inputStream\n");
      }

      //this is the most important part - calls StreamListener::onStopRequest
      //and StreamProvider::onStopRequest
      if (this._streamProvider) {
        dd("trying to cancel asyncWrite\n");
        this._write_req.cancel(2152398861);
        //this._write_req.cancel(NS_ERROR_CONNECTION_REFUSED); //nsIRequest
      }
    
      if (this._streamProvider) {
        this._streamProvider.close();
        dd("closed streamprovider \n");
      }
    //}
    dd("connected transport count: " + this._sockService.connectedTransportCount+"\n");
    dd("in use transport count: " + this._sockService.inUseTransportCount+"\n");

}

BCIConnection.prototype.sendData = 
    function bci_senddata(str)
{
  if (!this.isConnected) {
    dd("send failed. not connected.\n");
    //throw ("Not connected."); //commented out so as not to halt the prog
  } else {
    if (jsenv.HAS_NSPR_EVENTQ && jsenv.HAS_STREAM_PROVIDER)
        this.asyncWrite (str);
    else
        this.sendDataNow (str);
    dd("wrote " + str + "\n");
  }
}

BCIConnection.prototype.sendDataNow =
function bci_senddatanow(str)
{
    var rv = false;
    
    try
    {
        this._outputStream.write(str, str.length);
        rv = true;
    }
    catch (ex)
    {
        dd ("*** Caught " + ex + " while sending.");
        this.disconnect();
        throw (ex);
    }
    
    return rv;
}


BCIConnection.prototype.readData =
function bci_readdata(timeout, count)
{
    if (!this.isConnected)
        throw "Not Connected.";
    var rv;
    try
    {
        rv = this._inputStream.read (count);
    }
    catch (ex)
    {
        dd ("*** Caught " + ex + " while reading.")
        this.isConnected = false;
        throw (ex);
    }
    return rv;
}

BCIConnection.prototype.startAsyncRead =
function bci_saread (observer)
{ //new StreamListener(observer)
    if (jsenv.HAS_STREAM_PROVIDER)
    {
        this._transInterface.asyncRead (new StreamListener (observer),
                                   this, 0, -1, 0);
    }
    else
    {
        var cls = Components.classes["@mozilla.org/network/input-stream-pump;1"];
        var pump = cls.createInstance(Components.interfaces.nsIInputStreamPump);
        pump.init(this._inputStream, -1, -1, 0, 0, false);
        pump.asyncRead(new StreamListener(observer), this);
    }
}

BCIConnection.prototype.asyncWrite =
function bci_awrite (str)
{
    this._streamProvider.pendingData += str;
    if (this._streamProvider.isBlocked)
    {
        dd("was blocked, but resuming now...\n");
        this._write_req.resume();
        this._streamProvider.isBlocked = false;
    }
}

BCIConnection.prototype.hasPendingWrite =
function bci_haspwrite ()
{
    if (jsenv.HAS_STREAM_PROVIDER)
        return (this._streamProvider.pendingData != "");
    else
        return false; /* data already pushed to necko */
}

//Stream provider functions inserted from chatzilla
function StreamProvider(observer)
{
    this._observer = observer;
}

StreamProvider.prototype.pendingData = "";
StreamProvider.prototype.isBlocked = true;

StreamProvider.prototype.close =
function sp_close ()
{
    this.isClosed = true;
}
    
StreamProvider.prototype.onDataWritable =
function sp_datawrite (request, ctxt, ostream, offset, count)
{
    //dump ("StreamProvider.prototype.onDataWritable\n");
    if (this.isClosed)
        throw "Stream Closed";
        //throw Components.results.NS_BASE_STREAM_CLOSED;
    
    if (!this.pendingData)
    {
        this.isBlocked = true;
        //dd("no pending data - setting to blocked");
        throw Components.results.NS_BASE_STREAM_WOULD_BLOCK;
    }
    
    var len = ostream.write (this.pendingData, this.pendingData.length);
    this.pendingData = this.pendingData.substr (len);
}

StreamProvider.prototype.onStartRequest =
function sp_startreq (request, ctxt)
{
    //dd ("StreamProvider::onStartRequest: ");
}

StreamProvider.prototype.onStopRequest =
function sp_stopreq (request, ctxt, status)
{
    //dump("StreamProvider::onStopRequest: \n");
}

// Stream listener functions inserted from chatzilla
function StreamListener(observer)
{
    this._observer = observer;
}

StreamListener.prototype = {
  nrClasses: 0,
  readyReceived: false,
  classesReceived: false,
  resultValue: 0,
  paused: "yellow",
  lastTrialResult: new Date().getTime(), //not strictly correct, but we need some approximation
  trialLength: 7500, //approximation
  now: new Date().getTime()
}

StreamListener.prototype.onStartRequest =
function sl_startreq (request, ctxt)
{
  //dd ("StreamListener::onStartRequest: " + request + ", " + ctxt);
}

StreamListener.prototype.onStopRequest =
function sl_stopreq (request, ctxt, status)
{
  //dd("StreamListener::onStopRequest: " + request + ", " + ctxt + ", " + status);
}

// the stream is non-blocking
StreamListener.prototype.onDataAvailable =
function sl_dataavail (request, ctxt, inStr, sourceOffset, count)
{
  //dd("onDataAvailable called: " + inStr);
  ctxt = ctxt.wrappedJSObject;
  if (!ctxt)
  {
    dd ("*** Can't get wrappedJSObject from ctxt in " +
        "StreamListener.onDataAvailable ***");
    return;
  }
  if (!ctxt._inputStream)
  ctxt._inputStream = toScriptableInputStream (inStr);


  this.now = new Date().getTime();
  //if trialLength is too long, find some other value otherwise reading pause will be too long...
  //also important for msBeforeTrial, otherwise that value will be haywire if the triallength is too long. average over 3 values and don't take vals which are more than 100% larger...
  this.trialLength = this.now - this.lastTrialResult;
  this.lastTrialResult = this.now;
  dd("---trial length: " + this.trialLength);
  dd("---this.now: " + this.now);
  dd("---this.lastTrialResult: " + this.lastTrialResult);

  dd("sourceOffs: "+sourceOffset);
  dd("count: "+count);
  var bytesAvail; //see how much data arrived
  bytesAvail = ctxt._inputStream.available();    
  dd("bytes received: "+bytesAvail);
  
  var sis = Components.classes[SIS_CTRID].createInstance(nsIScriptableInputStream);
  sis.init(inStr);
  var buf;
  //buf = buf + sis.read(1);

  do {
    //take one byte at a time out of the input stream
    //buf = ctxt._inputStream.read(1); //read descriptor byte
    buf = sis.read(1);
    
    dd(".........." + buf.charCodeAt(0));
    // output what we received
    switch (buf[0]) {
    case recv_NRCLASSES : 
      buf += sis.read(1); //read content byte
      dd("..........Recv: NO. OF CLASSES: " + buf.charCodeAt(1)); 
      if (buf.charCodeAt(1) > 1) { //don't allow a value < 2
        this.nrClasses = buf.charCodeAt(1);
        this.classesReceived = true;
      }
      break;
    case recv_AREYOUREADY : 
      dd("..........Recv: ARE YOU READY?"); 
      if (this.readyReceived == false) {
        this.readyReceived = true;
        obsService.notifyObservers(null,"StartSurfing",null);
        dd("notified observer.");
      } else dd("not notifying observer.");
      break;
    case recv_RESULT : 
      buf += sis.read(1); //read content byte
      if (buf.charCodeAt(1) == "N") { //this is a hack
        dd("Recv: RESULT VALUE 0");
        this.resultValue = 0;
      }
      else {
        dd("Recv: RESULT VALUE " + buf.charCodeAt(1)); 
        this.resultValue = buf.charCodeAt(1);
      }
      if ((this.resultValue>=0) && (this.resultValue <= this.nrClasses)) {
        if (this.paused == "green") {
          
          obsService.notifyObservers(null,"StreamData",this.resultValue);
        } else if (this.paused == "yellow") {
          this.paused = "green"; //send next signal, but not current one
          dd("bci paused (yellow)");
          //window.status = "Jetzt geht's weiter!";
        } else { // this.paused == "red"
          dd("bci paused (red)");
        }
      } else dd("Result Value out of bounds! (Classes: " + this.nrClasses
                + ", Result: " + this.resultValue + ")");
      break;
    default : dd("Recv: ? (" + buf.charCodeAt(0) + ")");
    }

  } while (ctxt._inputStream.available() > 0);

}
