/* -*- Mode: Java; tab-width: 2; indent-tabs-mode: nil; c-basic-offset: 2 -*-*/
/***************************************************************
 * bci-static.js -----------------------------------------------
 *   Place JavaScript functions that are *not* event handlers in this file. 
 *   Contains global variables, class DialogArgs, class Commands
 * - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - 
 * REQUIRED IMPORTS: bci-utils.js (for XPCU)
 *                   navigator.js (for gBrowser, ...)
 *                   bci-prefs.js (for nsIAccessible)
 * - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - 
 * VERSION HISTORY:
 * 0.40: 
 * 0.35: added cats puzzle pics, option to reduce nr. of icons in navbar
 * 0.32: adding "redMsg", changing event handling for input fields
 * 0.31: added some keyboards which you can set in bci-prefs.js
 * 0.3 : added prefs, but not functional yet
 * 0.29: added commandset for bci commands, merged two dialog files
 * 0.28: adding rdf support for site-specific information storage
 * 0.27: added "focus" event listener, no need for "REFLOW" obs. any more
 * 0.26: added "REFLOW" observer for drawing frames
 * 0.25: get keyboard working with more than one letter
 ****************************************************************/

//include("chrome://jslib/content/jslib.js");
//commonDialog wraps the dialog in an object and provides getters and setters
//include("chrome://jslib/content/xul/commonDialog.js");
//include("chrome://jslib/content/io/dirUtils.js"); 
//include("chrome://jslib/content/rdf/rdfFile.js"); // loads other files autom.
//include("chrome://jslib/content/io/file.js");



//include("chrome://jslib/content/sound/sound.js");


// :::::::::::::::: global variables :::::::::::::::::::::::
const BCI_JS_VERSION = "0.35";

// ::::::::: communication protocol Mozilla --> BCI ::::::::
const send_IAMREADY   = "\001";
const send_PAUSE      = "\002";
const send_PAUSE_N    = "\003";
const send_CONTINUE   = "\004";
const send_STOP       = "\005";
const send_TRIGGER    = "\006";
// ::::::::: communication protocol BCI --> Mozilla ::::::::
const recv_NRCLASSES   = "\001";
const recv_AREYOUREADY = "\002";
const recv_RESULT      = "\003";

//already declared in navigator.js
//const nsIWebNavigation = Components.interfaces.nsIWebNavigation;
const obsService=XPCU.getService("@mozilla.org/observer-service;1",
                                 "nsIObserverService");
const accService=XPCU.getService("@mozilla.org/accessibilityService;1",
                                 "nsIAccessibilityService");

var manager;
var gBundle;
var gPref;
var gPauseButton;
var logWin = null; // window where the user performance is displayed


var gUrlBar = document.getElementById("urlbar"); // region for entering URLs
//var gNavBar = null; 


//var gEls;
//gEls = XPCU.createInstance("@mozilla.org/supports-array;1", 
//                         "nsISupportsArray");

var gPushPop; //global debug variable to store the difference between pushes and pops on the menuArray

var gTask = null; // global variable to store selected target element
var gTaskType = 0; // 1= dom.name, 2=acc.name, 3=dom.id 
var accTask = null; // new global variable for task accessible

var testVar = 10;// test variable 


const XHTMLNS = "http://www.w3.org/1999/xhtml"; //grab xhtml links
const XLinkNS = "http://www.w3.org/1999/xlink";
const XULNS = "http://www.mozilla.org/keymaster/gatekeeper/there.is.only.xul";

var theXList = [];
var theWindow = null;
var theDocument = null;
var linkList = new Array();
var linkIndex = 0;


////////////////////////////////////////////////////////////////////////////
//// "class" DialogArgs (advantage of a class is that we set defaults here)

function DialogArgs() {}

DialogArgs.prototype = 
  {
    // :::::::::::::::: Initialization :::::::::::::::::::::::::
    type: JS_CD_MESSAGE, //see commonDialog.js for constants 
    pic: null, // additional graphic displayed below the timer
    message: null,
    buttontype: null, //
    buttonList: new Array(),
    buttonAlign: JS_CD_CENTER, //see commonDialog.js for constants 
    title: null,
    timer: 0, //0: no timer, >0: number of seconds to wait before closing
    closeCondition: 0, //if closeCondition is true, the dialog closes
    eventYes: null, //event to start when dialog closes
    eventNo: null,
    eventTimerClose: null,
    eventDefault: null,
    position: null, // |side| or |info|

    // :::::::::::::::::: Properties :::::::::::::::::::::::::::
    get x() { 
    },
    set x(aVal) { 
    },
  }

/**
 * "class" Commands (to make the event flow configurable)
 * Add more methods to extend the system.
 * Each command should decide whether or not it wants to call userWait
 * and what the next type of menu to create should be (DOM,Bar,Acc...)
 */

/* More commands:
BrowserReload()
*/

function Commands() {
  dd("new Commands() function called");
}

Commands.prototype = {
    instance : null,

    getInstance: function() {
      if (!Commands.prototype.instance) {
        Commands.prototype.instance = new Commands();
        dd("new Commands called");
        }
        
      return Commands.prototype.instance;
    },

    // :::::::::::::::: Initialization :::::::::::::::::::::::::
    shortWait: 2, //Math.ceil(gPref.viewPageDelay/2),
    type: null,

    // :::::::::::::::::::: Methods ::::::::::::::::::::::::::::
    chooseLink: function() {
      dd("chooselink");
      if (manager) manager.createMenu("content",1);
      else dd("Erst verbinden.");
    },

    browserBack: function() { //page load event - no new menu created here
      //! first check whether we CAN go back or not !!!
      dd("browserBack()");
      BrowserBack();
      dd("should have executed");
      //      gMenuSource = gPref.menuSource;
    },

    pageDown: function() {
      getBrowser().docShell.QueryInterface(Components.interfaces.nsITextScroll).scrollByPages(1);
      //gMenuSource = gPref.menuSource;
      if (manager) 
      manager.userRead(gPref.viewPageDelay); //creates menu automatically
    },

    pageUp: function() {
      getBrowser().docShell.QueryInterface(Components.interfaces.nsITextScroll).scrollByPages(-1);
      if (manager)
      manager.userRead(this.shortWait); 
    },


    textEnlarge: function() {
      ZoomManager.prototype.getInstance().enlarge();
      //gMenuSource = gPref.menuSource;
      if (manager) manager.userRead(this.shortWait); 
    },
    textReduce: function() {
      ZoomManager.prototype.getInstance().reduce();
      //gMenuSource = gPref.menuSource;
      if (manager) manager.userRead(this.shortWait); 
    },

    gotoBookmarks: function() { //page load event - no new menu created here
      /* Only uncomment the following line if you want to use
       * Preferences -> Navigator -> Home Page as your home page.
       */
      // BrowserHome(); 
      // loadURI("resource:/res/bci/welcome.html",""); //navigator.js function
      //loadURI("file:///C:/Dokumente%20und%20Einstellungen/bensch/Anwendungsdaten/Mozilla/Profiles/test/dkhcf9s5.slt/bookmarks.html","");
      //getBrowser().webNavigation.
      this.startCommand();
    },

    addBookmark: function() {
      dump("adding bm");
      // defined in bookmarksOverlay.js, gBrowser defined in navigator.js
      BookmarksUtils.addBookmarkForBrowser(gBrowser.webNavigation, false);
      // hack for flushing bookmarks
      //gBookmarksService.QueryInterface(Components.interfaces.nsIObserver).observe(aBookmarksService, "profile-before-change", "")

      BrowserFlushBookmarksAndHistory(); // defined in navigator.js
      //gMenuSource = gPref.menuSource;

      // insert an info dialog here
      var dargs = new DialogArgs(); // dargs = dialog arguments
      dargs.title = l10n("infoTitle");
      dargs.type = JS_CD_MESSAGE;
      dargs.pic = "chrome://bci/skin/icons/bookmark.gif";
      dargs.buttonList[0] = JS_CD_BTN_CANCEL;
      dargs.buttonAlign = JS_CD_CENTER;
      dargs.message = "Diese Seite wurde zu Ihren Lesezeichen hinzugefgt";
      dargs.timer = gPref.informationMessageDelay;
      dargs.position = "info";
      manager.displayUserMsg(dargs);

      if (manager) manager.activeMenu.step(-1000); // move to beginning of menu
    },

    startCommand: function() {
      eval(gPref.startCommand);
    },

    openKeyboard: function(aAccessible) {
      dd("openKeyboard(" + aAccessible + ")");
      if (manager) {
        closeMsgWindows(false);
        
        manager.msgWin = window.openDialog(gPref.keyboardContent, "", "chrome,dependent,dialog=no,alwaysRaised=yes", aAccessible);
        setTimeout("onOpenKeyboard(manager.msgWin)",400);
      }
    },

    playGame: function(aNumber) { // 99 is random pic!
      var picNum = aNumber;
      if (picNum == 99) { // choose a random pic
        picNum = (Math.round((Math.random() * 10)) % 6);

      }
      dd("playGame: picNum is: " + picNum);
      loadURI("resource:/res/bci/games/bild"+picNum+".html");
      //setTimeout("gogame()",2000);


    },

    tour: function() {
      var wasNavbarHidden = true; // remember state of navbar, restore later
      if (manager)
      manager.pauseBCI = "red"; // do not use incoming signals
      // hide navbar if it's visible
      var navbar = document.getElementById( NAVBAR_1 );
      var element = document.getElementById( 'bci-menuitem-toggleBar' );
      if (navbar) {
        var attribValue = navbar.getAttribute("hidden");
        if (attribValue == "false") { // navbar is showing
          wasNavbarHidden = false;
          goToggleToolbar(NAVBAR_1,'bci-menuitem-toggleBar'); // hide navbar
        }
      }
      doTour(); // in |bci-handlers.js|
      if (wasNavbarHidden == false)
      goToggleToolbar(NAVBAR_1,'bci-menuitem-toggleBar'); // show navbar
    },

    test: function() {
      dd("test command");
      var openWin = openDialog("chrome://communicator/content/openLocation.xul", "_blank", "chrome,modal,titlebar", window);
      var te = openWin.document.getElementById("dialog.input");
      dd("textbox: " + te); 
      var te1 = openWin.getElementById("dialog.input");
      dd("textbox: " + te1); 

      /*
      gUrlBar.value = "www.test.de";
      try {
        dd(gUrlBar);
        var urlAcc = accService.GetAccessibleFor(gUrlBar);
      } catch (ex) {
        dd("Failed to get accessible for url bar.");
      }
      dd("url bar acc is: " + urlAcc);
      dd("url text is: " + urlAcc.getText());
      */      
    }
  }

function gogame() {
  manager.menuElements = getAllAccs(window._content.document, false); 

      dd("length: " + manager.menuElements.Count());
      dd("el1: " + manager.menuElements.GetElementAt(1));

      manager.createMenu("puzzle",1);
      dd("created menu with puzzle.");
}

function closeMsgWindows(allowEvents) {
  if (manager.msgWin) { //another user message is still open, close that one
    dd("first have to close another user message...");
    manager.mMsgWinEvents = true; // often we want to disable events
    manager.msgWin.close(); 
    dd("window should have closed!");
    manager.msgWin = null;
  }
}

//code taken from linky.js and modified significantly
//return an nsISupportsArray of DOM elements from the page
function getDOMContent(aNode) {
  var theDoc = aNode.document;
  
  /*
  dd("window.window: "+window.window); //ChromeWindow
  dd("theDoc (window._content.document): "+theDoc); //HTMLDocument
  dd("window._content: "+window._content); //Window
  dd("document.title: " + theDoc.title);
  dd("document.body: " + theDoc.body); //HTMLBodyElement */
  dd("bgColor: "+theDoc.bgColor);
  /*  dd("images: "+theDoc.images); //HTMLCollection
  dd("nodeName: "+theDoc.nodeName); //"#document"
  dd("nodeType: "+theDoc.nodeType); //9
  dd("nextSibling: "+theDoc.nextSibling); //null
  dd("getBrowser(): " + getBrowser()); // XULElement
  */
 
  lnks = grabLinks(aNode, theDoc);
  dd("Number links found: " + lnks.length);
  //create an nsISupportsArray to pass into XPCOM
  var myArray = XPCU.createInstance("@mozilla.org/supports-array;1","nsISupportsArray");
 
  for (var i = 0; i < lnks.length; i++) {
    dd(i + ": " + lnks[i]);
    if (lnks[i].nodeType == Node.TEXT_NODE) {
      dump("Set to parent node!\n");
      lnks[i] = lnks[i].parentNode;
    }
    //DumpDOM(lnks[i]);
    /* Move the elements from HTMLCollection to a flat nsISupportsArray
       Possibility to throw out unwanted elements or break up image map
       elements even further
    */
    for (var j=0; j < lnks[i].length; j++) {
      //DumpDOM(lnks[i].item(j));
      myArray.AppendElement(lnks[i].item(j));
    }
  }
  dd("length of the flat supports-array: " + myArray.Count());
  return myArray;

}

function getFirstAcc(aNode) {
  dd("getFirstAcc(" + aNode + ")");
  
  //var accService = XPCU.getService("@mozilla.org/accessibilityService;1",
  //                               "nsIAccessibilityService");
  var accRoot = null;
  //test whether we can get an accessible from this
  while (!accRoot) {
    try {
      //DumpDOM(aNode);
      accRoot = accService.getAccessibleFor(aNode);

    }
    catch (ex) {
      dd("seems like we cannot find an accbl...");
      //try siblings
      if (aNode.nextSibling) {aNode = aNode.nextSibling; dd("trying next sibling"); }
      else if (aNode.hasChildNodes()) {
        dd("trying first child...");
        aNode = aNode.firstChild;
      } else {
        return null;
      }
    }
  }
  return accRoot;
}

/**
 * returns an nsISupportsArray of nsIAccessibles
 */
function getAllAccs(aNode, aSiblingsOnly) {
  dd("getAllAccs(" + aNode + ", " + aSiblingsOnly + ")");
  if (aNode)
    var accRoot = getFirstAcc(aNode);
  else {
    dd("could not find element: " + aNode);
    return null;
  }
  if (!accRoot) {
    dd("found no accessible in whole subtree!");
    return null;
  }
  
  //create an nsISupportsArray to pass into XPCOM
  myArray = XPCU.createInstance("@mozilla.org/supports-array;1","nsISupportsArray");
  if (myArray)
	dd("myArray OK");
  
  //if ((roleAccepted(accRoot)) && (stateAccepted(accRoot)))
    myArray.AppendElement(accRoot);
  dd("myArray length: " + myArray.Count());
  //dumpObjectTree(myArray);
  //find all accbls, also children (needed for image maps or links in tables)
  //filter the ones we do not want
  getKids(accRoot, aSiblingsOnly);

  dd("length of the accessibles supports-array: " + myArray.Count());
  /*for (var i=0; i < myArray.Count(); i++) {
    dd("element " + i + ": " + myArray.GetElementAt(i));
    dd("name: " + myArray.GetElementAt(i).accName);
    }*/
  return myArray;
}


function getKids(aAcc, aSiblingsOnly) {
dd("getKids(" + aAcc + ", " + aSiblingsOnly + ")");
  if (aAcc != null) {
    var kid,sib;
    if (!aSiblingsOnly) {
      kid = aAcc.firstChild;    // acc
      if (kid) {
        dd("found a kid");
        if (stateAccepted(kid) && roleAccepted(kid)) {
          myArray.AppendElement(kid);
          dd("app kid: " + kid.name + "\trole: " + kid.role + "\tstate: " + kid.state); //dectohex acc
         }
        
        getKids(kid, aSiblingsOnly);
      }
    }
    

    sib = aAcc.nextSibling; // acc
    if (!sib)
    dd("no more siblings!");
    if (sib) {
      if (stateAccepted(sib) && roleAccepted(sib)) { //if (stateAccepted(sib) && roleAccepted(sib)) {
        myArray.AppendElement(sib);
        dd("app sib: " + sib.name + "\trole: " + sib.role + "\tstate: " + (sib.state)); //dectohex acc
      }
      getKids(sib, aSiblingsOnly);
    }
  }
  else
   dd("aAcc is null");
}


function roleAccepted(aAcc) {
  var i;
  var textEdText;
  var role;
  //added 11.05.06
  var accName;

  //the try-catch block is neccessary because some accessibles do not return 
  //a role (this might be a bug...(see http://www.superflo.de/))
  try {
    accName = aAcc.name;
    dd("name is: " + accName);
    role = aAcc.role;  //acc
    dd("role is: " + role);
  } catch (ex) {
    return false;
  }
  // |true| can be returned on the first role match
  for (i=0; i < gPref.roles.length; i++) {
    dd("comparing to: " + gPref.roles[i]);
    if (role == gPref.roles[i]) {
      //ROLE_TEXT, only include if editable text!
      if (role == 42) {
        if  (!((aAcc.state) & (nsIAccessible.STATE_READONLY))) { //acc 
          // add a focus handler, we are assuming there is none yet
          // get the DOM node
          var nsIDOMNode;
          var nsIDOMElement;
          var nsIDOMEventTarget;
          nsIDOMNode = aAcc.getDOMNode(); //acc
          try {
            nsIDOMEventTarget = XPCU.QI(nsIDOMNode, "nsIDOMEventTarget");
            nsIDOMEventTarget.addEventListener("mousedown", onTextFieldFocus, false);
            dd("set mousedown attrib.%%%%%%%%%%%%%%%%%%%%%%:%:%:%:%:%:%:%:%:%:%%%%%%%%%");
          } catch (ex) { dd(ex); }
          return true; // role == 42 and not READONLY
        } else return false; // role == 42 but not editable text
      }
      return true; // role == gPref.roles[i] AND role != 42
    }
  } // iterate roles
  return false; // no appropriate role found
}

//compare = nsIAccessible.STATE_OFFSCREEN | nsIAccessible.STATE_INVISIBLE;
  //  | nsIAccessible.STATE_FOCUSABLE;


function stateAccepted(aAcc) {
  try {// try and catch added 10.05.06: some accessibles seem not to have a state 
    var i;
    var state = aAcc.state;  //acc
  
    compare = nsIAccessible.STATE_OFFSCREEN | nsIAccessible.STATE_INVISIBLE;
    dd("compare: " + compare); //decimalToHex(compare));  
    dd("state: " + state);
  
    dd("state & compare: " + (state&compare));
    //dd("!(state & compare): " + (!(state&compare)));
    //if (!(state & nsIAccessible.STATE_OFFSCREEN) && !(state & nsIAccessible.STATE_INVISIBLE)) {
    if (!(state & compare)) {
      //for (i=0; i < gPref.states.length; i++) {
        //dd("comparing to: " + gPref.states[i]);
        //if (state & gPref.states[i]) {
      return true;
      //}
      //}
    } else {
      dd("state fell through");
    }
    return false;
  }
  catch(e) {
    return false;
  }
}

/**
 * menuRedraw: used to redisplay the current menu in case another window
 * should have been moved over it. Use the browser "reload" button to 
 * generate a new menu, but then the user has to start from the top again.
 * @param aDelay Time to wait before redraw (menus need time to disappear)
 */
function menuRedraw(aDelay) {
  dd("menu redraw.");
  if ((manager) && (manager.activeMenu)) {
    if (manager.menuLocked == false) {
      setTimeout("manager.activeMenu.display(true);", aDelay);
    } else {
      dd("menu building, cannot redraw yet...");
      setTimeout("menuRedraw(0)", 500); // try again later, menu still building
    }
  } else dd("no menu active, cannot redraw.");
}


function goCount() 
{
  //var elements = document.getElementsByTagName('body');
  //dd("elements: " + elements);
  var theDoc = window._content.document;
 dd("displayMenu()");
  dd("window.window: "+window.window); //ChromeWindow
  dd("theDoc (window._content.document): " + theDoc); //HTMLDocument
  dd("window._content: "+window._content); //Window
  dd("document.title: " + theDoc.title);
  dd("document.body: " + theDoc.body); //HTMLBodyElement
  dd("bgColor: "+theDoc.bgColor);
  dd("images: "+theDoc.images); //HTMLCollection
  dd("nodeName: "+theDoc.nodeName); //"#document"
  dd("nodeType: "+theDoc.nodeType); //9
  dd("nextSibling: "+theDoc.nextSibling); //null
  dd("getBrowser(): " + getBrowser()); // XULElement
  
  //var element = window._content.document.getElementById("mike");
  //dd("first element: " + element);
  //getVisibleWords(element);

  var t;
  t = gatherTextUnder(document.getElementById('content'));
  if (t) dd(t);
  t = gatherTextUnder(document.getElementById('mike'));
  if (t) dd(t);
}

/**
 * finds the number of visible words on the page to help determine a reading
 * pause
 */
function getVisibleWords(aNode) {
  var walker;
  //cf. http://lxr.mozilla.org/seamonkey/source/dom/public/idl/traversal/nsIDOMDocumentTraversal.idl#53 for |createTreeWalker|
  walker = document.createTreeWalker(aNode,
                                     NodeFilter.SHOW_TEXT,
    {
      acceptNode : function(node) {
        if (node.nodeType == Node.TEXT_NODE &&
            !(/[^\t\n\r ]/.test(node.nodeValue))) //filter out whitespace
        return NodeFilter.FILTER_REJECT;
        return NodeFilter.FILTER_ACCEPT; //if |if| statement fails
      }
    },
                                     true);
  addTree(walker);
}

/**
 * Function that is called recursivly to create the output tree
 */
function addTree(walker) {

  // walk the TreeWalker tree...
  if(walker.firstChild()) {

    do {
        
      // ...and create an output node for every node we find
      var newNode;
      switch (walker.currentNode.nodeType) {
      case Node.ELEMENT_NODE:
        newNode = document.createElementNS(null, "tag");
        newNode.setAttribute("name", walker.currentNode.nodeName);
        break;

      default:
        newNode = document.createElementNS(null, "text");
        newNode.setAttribute("value", walker.currentNode.nodeValue);
        break;

      }

      // insert the output node and recursivly walk the children
      // of every node
      //destNode.appendChild(newNode);
      dd("appending: " + newNode);
      dd("name:      " + newNode.getAttribute("name"));
      dd("value:     " + newNode.getAttribute("value"));
      addTree(walker);
      
    } while(walker.nextSibling());
    
    // don't forget to return the treewalker to it's previous state
    // before exiting the function
    walker.parentNode();
  }
}


/* ----------------------------------------------------------------------
 * Timer object. Executes a specified function after a specified number
 * of milliseconds, if a specified condition is met. To always execute the
 * function, simply pass a boolean 'true' to Timer::condTimedExec.
 * Original code taken from: xpfe/components/updates/src/nsUpdateNotifier.js
 * Contributor(s):
 *  Samir Gehani <sgehani@netscape.com> (Original Author) 
 *  Michael Bensch (changes for BCImoz)
 * ----------------------------------------------------------------------*/
function Timer()
{};

Timer.prototype =
{
    mTimer: null,
    condition: "",
    funcTrue: "",
    funcFalse: "",
    
    observe: function(aSubject, aTopic, aData) {
      dd("observe: " + aTopic);
      if (aTopic == "timer-callback") {
        mTimer = null; // free up timer so it can be gc'ed
        dd("condition("+this.condition+"): " + eval(this.condition));
        if (eval(this.condition) == true) {
          dd("Timer: executing " + this.funcTrue);
          eval(this.funcTrue);
        }
        else {
          dd("Timer: executing " + this.funcFalse);
          eval(this.funcFalse);
        }
      }
    },
    //in mSeconds millisecs, check aCondition. If true, executes aFunc
    condTimedExec: function(aCondition, aFuncTrue, aFuncFalse, mSeconds) {
      this.condition = aCondition;
      this.funcTrue = aFuncTrue;
      this.funcFalse = aFuncFalse;
      try 
      {
        mTimer = XPCU.createInstance("@mozilla.org/timer;1", "nsITimer");
        mTimer.init(this, mSeconds, Components.interfaces.nsITimer.PRIORITY_NORMAL,
                    Components.interfaces.nsITimer.TYPE_ONE_SHOT);
	
        dd("timer started with " + mSeconds);
        dd("timer delay: " + mTimer.delay);
      }
      catch (ex)
      {
        dd("Exception init'ing timer: " + ex);
      }
    }
}

/* get contributor's name */
function processDOM(aMenuSource)
{
  var f,x,i; 

    x = window._content.document.links; 
    for (i = 0; i < x.length; ++i) { 
      //if (x[i].target == "_blank") //maybe faster without the "if", may be able to get js openwin statements as well like this! test
      x[i].target = "_self"; //prevent open in new win
      //x[i].addEventListener("mouseout", gotest, false);
      //x[i].addEventListener("paint", gotest, false);
    }
  dd("processed DOM.");
}


/* ----------------------------------------------------------------------
 * Finds all links in a window and document.
 * Original code taken from: comm/content/navigator/pageinfo.js
 * Contributor(s): smorrison@gte.com
 *   Terry Hayes <thayes@netscape.com>
 *   Daniel Brooks <db48x@yahoo.com>
 *   Michael Bensch
 * ----------------------------------------------------------------------*/
function grabLinks(aWindow,aDocument)
{
  var theList = [];
  var i,j; //loop variables
  //dd("grabLinks()");
  //recursive part for finding all the frames (MB)
  if (aWindow && aWindow.frames.length > 0) 
  {
    var num = aWindow.frames.length;
    dd("Frames found: " + num);
    for (i = 0; i < num; i++)
    {
      var frame = aWindow.frames[i];
      //theList = theList.concat("frame.doc: "+frame.document.title); //!!!
      theList = theList.concat(grabLinks(frame, frame.document));
    }
  }

  /*theList = theList.concat(aDocument.getElementsByTagName("link"));
    The above line gets all elements with tag name "link", which are mainly
    style sheets we do not need. Commented out. MichaelB
  */

  //include only the first input field of a form
  //var formList = theList.concat(aDocument.getElementsByTagName("form"));
  var formList = aDocument.forms;
  theList = theList.concat(aDocument.getElementsByTagName("input"));
  //  var inputList = aDocument.getElementsByTagName("input");
  //if (inputList[i].type.toLowerCase() == "submit") 
  //possible types of the "input" element: 
  //hidden,text,password,image, file,radio, reset
  
  /*
  for (i = 0; i < formList.length; i++) {
    var formElements = formList[i].elements;
    for (j = 0; j < formElements.length; j++) {
      //only include "text" and "password" type input into our list
      //we will fire "submit" event when we're ready
      var elType = formElements[j].type.toLowerCase(); 
      if (elType == "text" || elType == "password" || elType == "select-one" ||
          elType == "radio") {
        if (elType == "select-one" || elType == "radio") {
          theList = theList.concat(formElements[j].parentNode);
          dd("form "+i+" el. "+j+" type: " + formElements[j].parentNode.type+" included");
        }
        else {
          theList = theList.concat(formElements[j]);
          dd("form "+i+" el. "+j+" type: " + formElements[j].type+" included");
        }
      }
      else dd("form "+i+" el. "+j+" type: " + formElements[j].type+" excluded");
    }
  }
  */ 

  if ("links" in aDocument) { //this is normally the case
    //every addition adds a new HTMLCollection!
    theList = theList.concat(aDocument.links); //includes HTMLAreaElement
    dd("links: " + aDocument.links.length);

    /* add forms */
//     if (aDocument.forms.length > 0)
//       theList = theList.concat(aDocument.forms);
//     dd("forms: " + aDocument.forms.length);

    /* add images */
    //if (aDocument.images.length > 0)
    //  theList = theList.concat(aDocument.images);
    //dd("images: " + aDocument.images.length);

    return theList;
  }
  else {
    dd("could not find links in HTML namespace, trying XHTML ns...");
    return theList.concat(aDocument.getElementsByTagNameNS(XULNS, "a"));
  }
  /*
  theList = theList.concat("Mike comment: before grabAllXLinks...");
  theList = theList.concat(grabAllXLinks(aDocument)); //original code (MB)
  theXList = grabAllXLinks(aDocument); //added this (MB)
  this causes problems sometimes: "hasAttributeNS is not a function"
  */
}

//Not used at the moment (MichaelB)
function grabAllXLinks(aDocument)
{
  dd("grabAllXLinks()");
  function XLinkFilter() 
  {
    this.acceptNode = function(aDocument)
    {
      return (aDocument.hasAttributeNS(XLinkNS, "href")) ? NodeFilter.FILTER_ACCEPT : NodeFilter.FILTER_SKIP;
    }     
  }

  var nodeFilter = new XLinkFilter;
  var iterator = aDocument.createTreeWalker(aDocument, NodeFilter.SHOW_ELEMENT, nodeFilter, true);
// why doesn't this work? the same thing works in findFirstControl() :P
//  var iterator = aDocument.createTreeWalker(aDocument, NodeFilter.SHOW_ELEMENT, XLinkFilter, true);

  var theList = new Array();

  while(iterator.nextNode())
    theList = theList.concat(iterator.currentNode);

  return theList;
}

//return a locale-dependent string (for cleaner code)
function l10n(aString) {
  return gBundle.getString(aString);
}

//restarting too often...
function checkConnection() {
  var running;
  running = document.getElementById("bci-menuitem-start").getAttribute("disabled");
  dd("running: " + running);
  dd("msAfterTrial: " + manager.sock.msAfterTrial);
  if ((manager.sock.msAfterTrial > gPref.connectionTimeout*1000) && running) {
    dd("no connection to BCI. Restarting...");
    manager.restart();
  }
}



/*
function testdelay() {
      manager.menuElements = getDOMContent();
      //      setTimeout("displayMenu()",250); //allow paint to finish
      try {
        manager.activeMenu.build(manager.menuElements,null); //pass in the array of DomNodes
        //setTimeout("manager.activeMenu.display(true)",1000); //temp test
        
//var cols = manager.activeMenu.classColors;
        //dd("colors: " + cols);
      } catch (ex) {
        dd("menu not working...");
      }
}
*/

// var winType = document.documentElement.getAttribute("windowtype");
//dd("displayUserMsg: current winType: " + winType);

 //dd("winType: " + winType);
  // if (window._content && winType == "navigator:browser")
  //  window._content.location.href = aUrl;
  //  else
  
  //first cycle windows to see whether another window is still open by 
  //mistake. If yes, close other window first or reuse...
  //window.open(aUrl, "Message", "chrome"); 

  //  netscape.security.PrivilegeManager.enablePrivilege("UniversalXPConnect");
  //netscape.security.PrivilegeManager.enablePrivilege("UniversalBrowserWrite");

// There is a bug which does not allow us to get the caret position
            // if the input field is empty. So we set a value as a bugfix
            // get the DOM Element
            //var tStr = new Object();
            //tStr = textEdText.getText(0,20);
            //textEdText.setTextContents("");
            //textEdText.setTextContents(tStr);
          
            //this was working
            //textEdText.copyText(0,20);
            //textEdText.setTextContents("");
            //textEdText.pasteText(0);
                   