/* -*- Mode: Java; tab-width: 2; indent-tabs-mode: nil; c-basic-offset: 2 -*-*/
/***************************************************************
 * Manager ---------------------------------------------------
 *   Object for controlling information flow between socket  
 *   interface and menu, and for calling commands
 *   Cartoons are copyright Ron Leishman, http://www.toon-a-day.com
 * - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - 
 * REQUIRED IMPORTS: bci-static.js (for global variables and commands)
 *                   bci-prefs.js  (for Prefs "object" and NAVBAR consts)
 *                   bci-socket.js (for BCIConnection "object")
 *                   bci-utils.js  (for XPCU)
 *                   navigator.js  (for common browser functions, see code)
 *              utilityOverlay.js  (toggle tool bar)
 ****************************************************************/

//getBrowser().docShell.QueryInterface(Components.interfaces.nsIWebProgressListener).???;
//include("chrome://jslib/content/jslib.js");



////////////////////////////////////////////////////////////////////////////
//// class Manager

function Manager()
{
  dd("Manager()");
  //load locale-dependent strings

  //gMenuSource = gPref.menuSource;
  gPushPop = 0;
  
   
  //window.addEventListener("mousemove", processMouseMove, false);
  this.menuElements = XPCU.createInstance("@mozilla.org/supports-array;1", 
                                         "nsISupportsArray");

  registerBCIObservers();
  //test the sound thing...
  //s = new Sound("resource:/res/bci/sound.wav"); //
  //setTimeout("s.play();",10000);

}

Manager.prototype = 
{
  // :::::::::::::::: Initialization :::::::::::::::::::::::::
  menuElements: null,
  menuLocked: false, // Transaction var. If locked, can not display yet!
  menuArray: new Array(), //holds all menus still needed in memory
  activeMenu: null, //the menu currently being shown
  sock: null, //socket connection to BCI
  //mCommand: new Commands(), //defined in bci-static
  //c: new Commands(), 
  msgWin: null, //set this variable if a message window is open
  mMsgWinEvents: true, //false: no event processing on close
  mIntervalID: 0,
  mState: 0,
  

  // :::::::::::::::::: Properties :::::::::::::::::::::::::::
  get nrClasses() { 
    if ((this.sock) && (this.sock.nrClasses > 1)) {
      return this.sock.nrClasses; 
    } 
    else 
    return gPref.defaultClassCount;
  },
  set nrClasses(aVal) { //can I delete whole function?
    dd("nrClasses is read-only.");
  },
  get pauseBCI() {
    return this.sock.streamListener.paused;
  },
  set pauseBCI(aVal) { //aVal must be "red", "yellow", or "green"
    this.sock.streamListener.paused = aVal;
    //update menu items
    if ((aVal == "red") || (aVal == "redMsg")) {
      gPauseButton.setAttribute("checked", "true");
      try {
        dd("REMOVING OBSERVERS");
        obsService.removeObserver(gBCIobserver,"StartDocumentLoad",false);
        obsService.removeObserver(gBCIobserver,"EndDocumentLoad", false);
        obsService.removeObserver(gBCIobserver,"FailDocumentLoad", false);
      } catch (ex) { dd("XXXXXXXXXXXXXXXXXerror removing observers"); }

      if (aVal == "redMsg") { // additionally open a message window
        var dargs = new DialogArgs();
        dargs.title    = l10n("supervisorTitle");
        dargs.message  = l10n("supervisorMsg"); 
        dargs.position = "side"; // should obscure feedback window
        //manager.displayUserMsg(dargs);
        dd("window would open here...");
      }
    } else { //if pause is "yellow" it can be set to "red" again
      gPauseButton.setAttribute("checked", "false");
      obsService.addObserver(gBCIobserver, "StartDocumentLoad", false);
      obsService.addObserver(gBCIobserver, "EndDocumentLoad", false);
      obsService.addObserver(gBCIobserver, "FailDocumentLoad", false);
    }

    dd("SET PAUSE: " + aVal);
  },
  
  // :::::::::::::::::::: Methods ::::::::::::::::::::::::::::  
  init: function(aFirstStart)
  {
    dd("Manager::Init(" + aFirstStart + ")");
    //open socket connection
    try {
      this.sock = new BCIConnection();
    }
    catch (ex) {
      dd("Could not create socket: " + ex);
    }
    var connected = false;
    connected = this.sock.connect(gPref.host, gPref.port, null); 
    this.sock.sendData(send_IAMREADY); //test connection, handshake
    //if no answer within a specified time, display message
    

    
  },

  //either READY or NRCLASSES was not received, or there is no connection at
  //all. Disconnect, display message, wait 10 seconds, then try again.
  restart: function()
  {
    dd("manager::restart()");

    this.sock.disconnect();
    this.sock = null; //allow this to be garbage collected
    this.init();
    /*
      var mDialogArgs = new DialogArgs();
      mDialogArgs.title = l10n("infoTitle");
      mDialogArgs.message = l10n("infoMsg");
      mDialogArgs.type = JS_CD_INFO;
      mDialogArgs.pic = "resource:/res/bci/images/96_09_09_dilemma.jpg";
      //mDialogArgs.timer = 5;
      mDialogArgs.closeCondition = "(window.opener.manager.sock.readyReceived && window.opener.manager.sock.classesReceived)";
      mDialogArgs.eventDefault = "setTimeout('manager.init();',100);";
      //mDialogArgs.eventYes = "dump('Betreuer hat ja!')";
      mDialogArgs.eventNo = "dump('Betreuer hat nein!')";
      //mDialogArgs.eventTimerClose = "setTimeout('manager.init();',5000);";

      
      this.displayUserMsg(mDialogArgs);
    */

    //this is a hack. should use above lines.
    //setTimeout("manager.init();",10500); //can't use "this"
  },
  userRead: function(aDelay)
  {
    manager.createMenu(gPref.menuSource,1); // this blocks the UI!
  

    if (aDelay > 0) {
      var mDialogArgs = new DialogArgs();
      mDialogArgs.title = l10n("readTitle");
      mDialogArgs.type = JS_CD_MESSAGE;
      mDialogArgs.pic = "resource:/res/bci/images/book_pile.gif";
      mDialogArgs.buttonList[0] = JS_CD_BTN_CANCEL;
      //mDialogArgs.buttonList[1] = "Anhalten";
      mDialogArgs.buttonAlign = JS_CD_CENTER;
      mDialogArgs.message = l10n("readMsg"); //use bundle
      mDialogArgs.timer = aDelay;
      // eventDefault: supervisor presses <ESC>, eventNo: <Cancel> button pressed
      mDialogArgs.eventDefault = "menuRedraw(50);";
      mDialogArgs.eventNo = "manager.pauseBCI='yellow'; window.opener.menuRedraw(50);" //window.opener.manager.createMenu();"; // we need window.opener in second statement!
      mDialogArgs.position = "side";
      this.displayUserMsg(mDialogArgs);
    } else {
      closeMsgWindows(false);
      menuRedraw(50);
    }
    dd("finished userRead");
  },

  displayUserMsg: function(aDialogArgs) {
    
    closeMsgWindows(false); // see bci-static.js
      
    //to refer to the new window: use the name "userMsg" from parent windows,
    //and use the variable "userWin" from program code
    // |titlebar,close| are on by default
    //class = "dialog" prevented resizing of the windows
    if (aDialogArgs.position == "side") {
      this.msgWin=window.openDialog("chrome://bci/content/dialog-side.xul",
      "userMsg","chrome,dependent,dialog=no,alwaysRaised=yes", aDialogArgs);
    }
    else { //info
      this.msgWin=window.openDialog("chrome://bci/content/dialog-info.xul",
      "userMsg","chrome,dependent,dialog=no,alwaysRaised=yes", aDialogArgs);
    }
  },

  /**
   * if aSource == "" then we already have filled menuElements
   */
  createMenu: function(aSource, aDisplay) { 
    dd("createMenu(" + aSource + ", " + aDisplay + ")");
    now = new Date();

    // hide old menu if a new one is created
    if (this.activeMenu) {
      this.activeMenu.display(false);
      this.activeMenu = null;
      if (gPref.allowURL) {
        try {
          urlbar.removeEventListener("mousedown", onTextFieldFocus, false);
        } catch (ex) {} // non-fatal error
      }
    }
    this.menuLocked = true; 
    try {
    	this.activeMenu = XPCU.createInstance("@bci/menu;1","bciIMenu");
      /* 23.11.06 (bensch): can be removed if above line works
      const kClass = "@bci/menu;1";
      var obj = Components.classes[kClass].createInstance();
      obj2 = obj.QueryInterface(Components.interfaces.bciIMenu);
      //alert("Testing: treetype: " + obj2.treeType);
       
      this.activeMenu = obj2; 
      */
      this.activeMenu.verifyFrequency = gPref.verifyFrequency;
      this.activeMenu.finalVerify = gPref.finalVerify;
      this.activeMenu.treeType = gPref.treeType;
      this.activeMenu.classCount = this.nrClasses;
      this.activeMenu.classColors = gPref.classColors;
      this.activeMenu.outlineStyle = gPref.outlineStyle;
      this.activeMenu.targetOutlineStyle = gPref.targetOutlineStyle;
      this.activeMenu.targetClassColors =gPref.targetClassColors;
    } catch (ex) {
      this.menuLocked = false;
      dd("Error creating menu: " + ex);
      // do not continue in this function...
      dd("Output a nice user message here");
      alert("Error creating menu");
      // and do not continue afterwards!!!
    }

    //this.menuArray.push(this.activeMenu); gPushPop += 1;
    
    // get menu elements from arbitrary source
    dd("getting menu elements");
    if (aSource == NAVBAR_1_BUTTONS) {
      //this.menuElements.Clear();
      // check visibility of navigation bar. Unvisible --> default action
      var navBar = document.getElementById(NAVBAR_1);
      if (navBar.getAttribute("hidden") == "true") {
        dd("default action - content source");
        this.menuElements = getAllAccs(window._content.document, false); 
      } else {
        dd("nav source.");
        navBar = document.getElementById(NAVBAR_1_BUTTONS);
        this.menuElements = getAllAccs(navBar, true);
        var urlbar = document.getElementById("urlbar");
        if (urlbar && gPref.allowURL) {
          //DumpDOM(urlbar);
          //var urlInput = urlbar.getElementsByTagName("input");
          //dd("found elements: " + urlInput);
          urlbar.addEventListener("mousedown", onTextFieldFocus, false);
          this.menuElements.AppendElement(urlbar);
          dd("appending urlbar: " + urlbar);
        }
      }
    } else if (aSource == "dialog") {
      dd("dialog source.");
      //this.menuElements.Clear();
      this.menuElements = getAllAccs(this.msgWin.window.document, false);
    } // added 10.05.06: need accs in mail window
      else if(aSource == "secondWin") {
      dd("second window source. ");
      //this.activeMenu.display(false);
      var wm = Components.classes["@mozilla.org/appshell/window-mediator;1"].getService(Components.interfaces.nsIWindowMediator);
      var mailWin = wm.getMostRecentWindow("mailWindow");
      dd("mailWin" + mailWin);
      //this.menuElements.Clear();
      this.menuElements = getAllAccs(mailWin.document, false);
    
    } else if (aSource == "content") {
      // set the stop button to active
      dd("xulbrowser: " + window.XULBrowserWindow);
      window.XULBrowserWindow.stopButton.removeAttribute("observes");
      window.XULBrowserWindow.stopButton.disabled = false;

      dd("content source, getting accessibles...");
      //this.menuElements.Clear();
      this.menuElements = getAllAccs(window._content.document, false);
    } else if (aSource == "puzzle") {
      dd("already have menu elements: " + this.menuElements);
      dd("count: " + this.menuElements.Count());
    }

    dd("finished getting menu elements - starting build");


    var elCount; //returns number of elements in menu (PRUint8)
    try {
      //pass in the array of DomNodes or Accbls
      //returns with error if no on-screen elements exist
      now1 = new Date();
      
      elCount = this.activeMenu.build(this.menuElements); 
      
      
     /***********************************
     * logging
     ***********************************/
     //if(!(this.activeMenu.getTaskFlag())) { //logging has finished
     if(this.activeMenu.getTaskFlag()==0) { //logging has finished
       dd("logging has finished: reset gTask and gTaskType");
       gTask = null;
       gTaskType = 0;
     }
     
     
             
      now2 = new Date();
      this.menuLocked = false;
      

      dump("build returned: " + elCount + " elements in menu.\n");
      dump("JS time:  " + (now1-now) + " ms\n");
      dump("CPP time: " + (now2-now1) + " ms\n");

      if (elCount == 0)
        this.autoStep(gPref.autoStep, "noElementsMsg");
      else if (aDisplay == 1) 
        menuRedraw(0);
 
    } catch (ex) {
      this.menuLocked = false;
      // impossible to build menu (maybe no elements or error in .dot file)
      dd("menu not working");
      dd("ex: " + ex);
      // open Dialog stating that menu is not working
      var dargs = new DialogArgs(); // dargs = dialog arguments
      dargs.title = l10n("infoTitle");
      dargs.message = l10n("noMenu");
      dargs.timer = gPref.informationMessageDelay;
      dargs.position = "info";
      dargs.eventDefault = "manager.createMenu(NAVBAR_1_BUTTONS,1);";
      manager.displayUserMsg(dargs);

      

    }


    //during this time the trial is already starting...
    //commented this line out because we have now found a pref that should
    //block any new windows from opening. (browser.block.target_new_window)
    //processDOM(aSource); 
  },

  autoStep: function(aCommand, aMsg) {
    var args          = new DialogArgs();
    args.type         = JS_CD_MESSAGE;
    args.title        = l10n("infoTitle");
    args.message      = l10n(aMsg); 
    args.timer        = gPref.informationMessageDelay;
    args.eventDefault = aCommand;
    args.position     = "info";
    this.displayUserMsg(args);
  },

  shutDown: function()
  {
    //this is never reached when closing mozilla :-(
    dd("!!!!!!!!!!!!!!!!!!!!Manager::shutDown()!!!!!!!!!!!!!!!!!!!!\n");

    /*if(this.activeMenu) {
      completeLogFile();//write last matrix to file
    }*/
    if(logWin) {
      logWin.close(); //LogWindow is closed
      logWin = null;
    }
    unregisterBCIObservers();
    this.sock.sendData(send_STOP);
    this.sock.disconnect();
    sock = null;
    // close any open dialog windows
    closeMsgWindows(false);
    // remove coloured frames from elements
    if (this.activeMenu) {
      //this.activeMenu.setTaskFlag(true);
      //reset all variables needed for logging
      gTask = null;
      gTaskType = 0;
      this.activeMenu.taskID = "";
      //this.activeMenu.setGTaskTypeC(0);
      this.activeMenu.taskType = 0;
      this.activeMenu.setTaskFlag(false);
      
      this.activeMenu.display(false);
      this.activeMenu = null;
    }
  }
  
   
};

/*
  var t = new Timer();
  var cond= "manager.sock.streamListener.readyReceived";
  //var cond = true; //always start, even without connection!
  var func = "manager.startEvents()"; //can't use "this" here
  var funcFalse = "manager.init()";
  //allow 1 second for server to respond according to the protocol:
  //server must send "READY" signal and "NRCLASSES"
      
  //wait, then execute
  t.condTimedExec(cond, func, funcFalse, gPref.serverTimeout); 
  dd("--------SEND CLASSES NOW!!! --------");
*/


/*
 * During browser test, this caused problems with the filter.
 * Disabling. Filter will now always send its signals.
 *
 if (this.mPauseBCI == true) {
 this.sock.sendData(send_PAUSE);
 dd("PAUSE (didnt send)");
 } else {
 this.sock.sendData(send_CONTINUE);
 dd("CONTINUE (didnt send)");
 }
*/

